Subject: Re: Home Web Server

From: Keith Smith via PLUG-discuss <[email-masked]>
Date: Wed, 30 Apr 2025 07:50:45 -0700

Thanks Stephen,

<scroll>

On 2025-04-21 06:39, Stephen Partington via PLUG-discuss wrote:
> I have a pair of servers running, 1 is an older Dell PowerEdge 1U
> single Xeon that is my firewall running Opnsense (harder than I
> expected to use but liking it) , and the other is a more robust server
> I built with an AMD x5900 and 128 GB of RAM. IT also has a lot of
> storage, and its job is to run Proxmox. On it has a bout 7 VM's
> running doing various things, from NExtCloud, Open Media Vault, and my
> one Windows server for the 3 things I cannot run in Linux. I also have
> a load balancer and a few other things running. I also do a ton of
> random things that ill spin up, try out, and then drop as a failure or
> not what i was looking for.
> 
> If you have a domain name and use CloudFlare, there are scripts that
> will automatically update CloudFlare DNS routes when they detect a
> change. There are scripts for a bunch of services, you just have to go
> looking.
> 

I have a static IP with the ability to get more.  I assume CloudFlare 
DNS would be a solution for most.

> On Sun, Apr 20, 2025 at 8:06 PM David Schwartz via PLUG-discuss
> <[email-masked]> wrote:
> 
>> I had a little Debian-based box installed at a co-lo locally for 7
>> years that I ran myself. After the HDD died the 3rd time, I decided
>> to pull the plug on it.
>> 
>> That was back around 1995-2002 time-frame.
>> 
>> It had a Mini-ITX mobo with a 600 MHz x86 clone chip, maybe 256MB of
>> RAM, and a 20 GB HDD in it. The Ethernet port was 10Mbps. It took a
>> lot of care and feeding.
>> 
>> I think a Rasperry Pi Pico would have the same performace that that
>> little box had. :)
>> 
>> I’ve thought about setting up a local server at home, but mainly
>> as a local file server. I have a Dropbox Plus account that gives me
>> 2TB of storage, but I’m not about to mirror that on all of my
>> machines. It would be nice to have it mirrored to a local file store
>> instead that had a driver that let you treat it as a local drive (as
>> if it was plugged into a USB port).
>> 
>> I think I have 8 computers attached to my LAN at home right now: 3
>> Mac Minis, a little Windows box that’s like a Mac Mini (N150 CPU),
>> two iPads, and a MacBook Pro. The LAN is running at 1GB.
>> 
>> My internet here is from Cox; it’s Fiber and it goes 1GB both up
>> and down, but only if you connect via ethernet; the WiFi is about
>> 600 megs.
>> 
>> Cox won’t give me a static IP. Fiber to the home is a different
>> division than their Business group and they said they cannot run a
>> fiber line to the property for some reason. (It’s a big apartment
>> complex and I guess Cox Residential is their exclusive internet &
>> cable provider.)
>> 
>> So I’ve looked around to see what options I might have for setting
>> up a home file server that could also run a dynamic DNS for external
>> access. I’ve got a couple of RPi 4’s that I could use, or maybe
>> one of my Mac Minis.
>> 
>> The problem I ran into is that most of the info I found was for
>> hosting video streaming. Basic file hosting, like for mirroring
>> Dropbox, doesn’t seem to be of much interest. I could shut off
>> Dropbox if I had a decent file server, but there doesn’t seem to
>> be much demand for it. Maybe there is, but I haven’t found much
>> activity there.
>> 
>> Another area I found that might be of interest to you is showing
>> people how to set up a server that can host podcasts. Podcasting is
>> growing like crazy, and the size of the MP3 files is smaller than a
>> lot of HD photos, let alone videos.
>> 
>> I don’t know if there’s an open source Podcasting service that
>> does hosting, but it needs to have an RSS feed, which isn’t very
>> complicated. I think there’s a market for a simple Podcast hosting
>> device people could set up in their home that has a good set of
>> features on it. Personally, I’d like to see something like YouTube
>> but for audio podcasts. All of the big podcast platforms don’t
>> offer much. If you want comments and interactions between your
>> listeners, you need to set that up separately, whereas YT has all of
>> that built-in — which is probably why so many podcasts are hosted
>> there using a static page as the video. Just beware of the ads.
>> It’s kind of strange to me.
>> 
>> -David Schwartz
>> 
>>> On Apr 20, 2025, at 1:11 PM, [email-masked] wrote:
>>> 
>>> Thanks for your feedback David!!
>>> 
>>> Here is where I am coming from.  I think there are 3 types of
>> people.  System Admin, business folks, and hobbyists.  I used to
>> have a friend who is a sys admin and a programmer.  He does all his
>> own hosting.  There is a person on the list that has referred to his
>> home lab a few times.  I suspect most have some level of a home lab.
>>> 
>>> I was doing some research and found there is demand for learning
>> how to build and maintain a web server out of ones home/home
>> office/home lab.
>>> 
>>> My commercial advice is don't do it.  Much cheaper to rent shared
>> hosting or a VPS. That is my advice to a business owners.
>>> 
>>> Having said that I was able to configure an old laptop as a web
>> server + Bind+Postfix+Dovecot+let's Encrypt... and possible some
>> other packages.
>>> 
>>> I did it to learn and in the end I liked the fact that I could do
>> so. As you know I am a PHP dev. I made mention at the time that I
>> had bragging rights.  Was a big accomplishment for me.  I assume
>> being able to build a full stack web server pushes me in the realm
>> of being a full-stack developer.
>>> 
>>> The motivation for this post was based on some research I
>> performed that showed there is a fair amount of interest in leaning
>> how to build and maintain a web server out of ones home/home
>> office/home lab.
>>> 
>>> I posted hoping for feedback on what others might know of the
>> demand.
>>> 
>>> I learned a lot the first go around and would like to learn more.
>> And as you know I have a YouTube channel and blog.  I would like to
>> share my experience with others.
>>> 
>>> Keith
>>> 
>>> 
>>> 
>>> On 2025-04-19 21:47, David Schwartz via PLUG-discuss wrote:
>>>> I guess this all depends on if this is just a hobby for you or
>> something you want to make money from.
>>>> Here’s my opinion; it’s not exactly what you’re wanting to
>> hear, but it’s a legitimate option… I may have mentioned it
>> before.
>>>> Take a look at Latenode. It’s an automation service,
>> functionally similar to Zapier, Make, Pabbly, and others, but I
>> think its a lot more affordable.
>>>> Most web apps these days require logic to be hidden in a back-end
>> service to keep people from accessing your keys. As a result, the
>> majority of things the back-ends do is forwarding requests on to
>> other services, including DBs, AIs, and other things.
>>>> I really do not want to deal with my own server ANYWHERE — at
>> home or anywhere else in the world, especially if I can build little
>> modular services accessible as webhooks on an automation platform.
>> The servers they run on are fast, scalable, and made for heavy-duty
>> use. (Mostly cloud-based, I’m guessing.)
>>>> I can’t speak to the security issues, but nothing I’m doing
>> is worse than keeping my backend “secret keys” out of reach from
>> the front-end users. (If you don’t, they end up in your browser in
>> clear-text and they can be scraped without much trouble.)
>>>> If you’re really that paranoid and worried about stuff that it
>> makes sense to become an expert on all of those server-side tools on
>> a server you keep hidden in your home or office, then knock yourself
>> out. I don’t care; I don’t want to care, or even keep up with
>> the changes they’re constantly undergoing. I want to be able to
>> quickly set up a proxy to sit between my front-end and some other
>> service that gets me what I want without having to manage anything
>> you mentioned.
>>>> If you need some custom programming, then Latenode allows you to
>> use javascript in their nodes. Pickaxe works with Python, and it can
>> even help you write the code.
>>>> (Pickaxe is an interesting 2-faced thing, part of which is an
>> app-builder and part of which is has some basic logic and it can
>> trigger webhooks to other back-end services, including automation
>> services. They only mention Zapier and Make, but their interface is
>> not specific to either one except in name only. It works fine with
>> Latenode, Pabbly, and others. I think something called Lemonade is
>> somewhat competitive with Pickaxe.)
>>>> I know, folks on this list are going to complain that these
>> services are not free except for trivial purposes to get familiar
>> with them. But I value my time far more and I don’t mind paying a
>> couple hundred bucks a month to have SEVERAL high-quality services
>> managed for me so I don’t have to deal with anything to keep them
>> running. I did that for a while on a Windows VPS (which I had to use
>> b/c the code I needed only targets Windows) and problems were
>> constantly coming up; unfortunately, the VPS host didn’t provide
>> an support.
>>>> I bought a small Windows box to run at home to replace the VPS,
>> but I decided I can do pretty much anything I need on Latenode. So
>> it’s just sitting there.
>>>> I learned how to admin Unix boxes back in the 80’s, and it has
>> always been one of my least favorite things to do. I’m very happy
>> to pay people the cost of one restaurant dinner per month to keep my
>> services working. But my goal is to use these services to make
>> money, at which point the costs are going to be minscule compared to
>> the potential revenues.
>>>> If it’s not a hobby, then you need to decide if you want to
>> work ON your business or IN your business. Running your own server
>> means it’s all on you. Outsourcing it lets you work ON your
>> business.
>>>> TBH, I’m getting away from programming and all of this admin
>> crap. It’s about frigging time we’re seeing things start to bury
>> this stuff behind walls that are being run by AI services. Dealing
>> with AI prompts and automation tools is the future, IMHO. Working
>> with stuff that’s still clearly recognizable today from what it
>> looked like in the 80’s is hardly “progress”. I’ve had
>> people ask me over time, “Why don’t you get certified to work on
>> Cisco hardware?” I used to write code for devices like that back
>> in the 80’s, and it looks like it HAS NOT CHANGED AT ALL, just
>> like talking to modems and Epson printer escape codes.
>>>> This is 2025; I’ve been there, done that, and AI is the future.
>> Prompts are actually structured a lot like imperative programming
>> code but they use normal language to explain things. Unfortunately,
>> if you don’t know the basics of imperative programming, you’re
>> going to miss a lot of details and mess up the structure. And if you
>> aren’t an SME in the domain you’re trying to get AI to do for
>> you, you’re screwed.
>>>> Just my thoughts.
>>>> -David Schwartz
>>>>> On Apr 19, 2025, at 6:10 PM, Keith Smith via PLUG-discuss
>> <[email-masked]> wrote:
>>>>> Hi,
>>>>> I did some research and it appears there is a lot of demand for
>> content that covers how to create a web server out of home/home
>> office/home lab.
>>>>> I assume this means Linux, Apache, MySQL, PHP + Bind9, Postfix,
>> Dovecot, some form of webmail, Let Encrypt, and possibly other
>> servers/software.
>>>>> What does the list think on this subject?
>>>>> Keith
>>>>> ---------------------------------------------------
>>>>> PLUG-discuss mailing list: [email-masked]
>>>>> To subscribe, unsubscribe, or to change your mail settings:
>>>>> https://lists.phxlinux.org/mailman/listinfo/plug-discuss
>>>> ---------------------------------------------------
>>>> PLUG-discuss mailing list: [email-masked]
>>>> To subscribe, unsubscribe, or to change your mail settings:
>>>> https://lists.phxlinux.org/mailman/listinfo/plug-discuss
>> 
>> ---------------------------------------------------
>> PLUG-discuss mailing list: [email-masked]
>> To subscribe, unsubscribe, or to change your mail settings:
>> https://lists.phxlinux.org/mailman/listinfo/plug-discuss
> 
> --
> A mouse trap, placed on top of your alarm clock, will prevent you from
> rolling over and going back to sleep after you hit the snooze button.
> 
> Stephen
> ---------------------------------------------------
> PLUG-discuss mailing list: [email-masked]
> To subscribe, unsubscribe, or to change your mail settings:
> https://lists.phxlinux.org/mailman/listinfo/plug-discuss
---------------------------------------------------
PLUG-discuss mailing list: [email-masked]
To subscribe, unsubscribe, or to change your mail settings:
https://lists.phxlinux.org/mailman/listinfo/plug-discuss